
local DF = _G ["DetailsFramework"]
if (not DF) then
	print ("|cFFFFAA00Please restart your client to finish update some AddOns.|r")
	return
end

local floor = floor
local min = min
local UnitExists = UnitExists
local GetPlayerMapPosition = GetPlayerMapPosition
local UnitHealth = UnitHealth
local GetNumGroupMembers = GetNumGroupMembers
local abs = abs
local GetPlayerFacing = GetPlayerFacing
local db
local _

local f = DF:Create1PxPanel (_, 100, 20, "Iskar Assist", "IskarAssist", nil, "top", true)
f:SetFrameStrata ("DIALOG")
f.version = "v0.1"

f:SetSize (104, 100)
f:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, insets = {left = -1, right = -1, top = -1, bottom = -1}})
f:SetPoint ("center", UIParent, "center", 300, 200)
f:SetBackdropColor (0, 0, 0, 0.2)
f:SetBackdropBorderColor (0, 0, 0, 1)
f:SetMovable (true)
f:EnableMouse (true)
f:Hide()

local aura_eyeanzu = GetSpellInfo (179202) --Eye of Anzu
local aura_phantasmal_wounds = GetSpellInfo (182325) --Phantasmal Wounds
local aura_phantasmal_winds = GetSpellInfo (181957) --Phantasmal Winds
local aura_fel_chakram = GetSpellInfo (182178) --Fel Chakram
local aura_phantasmal_corruption = GetSpellInfo (181824) --Phantasmal Corruption
local aura_fel_bomb = GetSpellInfo (181753) --Fel Bomb
local aura_phantasmal_bomb = GetSpellInfo (179219) --Phantasmal Fel Bomb

local frame_event = CreateFrame ("frame", "IskarAssistEvents", f)

frame_event:RegisterEvent ("ENCOUNTER_START")
frame_event:RegisterEvent ("ENCOUNTER_END")
frame_event:RegisterEvent ("ADDON_LOADED")
frame_event:RegisterEvent ("PARTY_MEMBERS_CHANGED")
frame_event:RegisterEvent ("GROUP_ROSTER_UPDATE")
frame_event:RegisterEvent ("PLAYER_ENTERING_WORLD")
frame_event:RegisterEvent ("UNIT_NAME_UPDATE")
frame_event:RegisterEvent ("PLAYER_REGEN_ENABLED")
frame_event:RegisterEvent ("PLAYER_TARGET_CHANGED")

frame_event:SetFrameStrata ("FULLSCREEN")
--
local isdebug = true
function f:debug (msg, msg2)
	if (isdebug) then
		print ("-", msg, msg2 or "")
	end
end

local db
f.player_blocks = {}

local block_backdrop = {bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, insets = {left = -1, right = -1, top = -1, bottom = -1}}
local block_backdrop_eye = {bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, insets = {left = 0, right = 0, top = 0, bottom = 0},
edgeFile = "Interface\\AddOns\\IskarAssist\\border_2", edgeSize = 20}

local anzu_texture = f:CreateTexture (nil, "overlay")
anzu_texture:SetTexture ("Interface\\ICONS\\ability_felarakkoa_eyeofterrok")
anzu_texture:SetSize (16, 16)
anzu_texture:SetTexCoord (4/64, 60/64, 4/64, 60/64)

--[[
local teste = CreateFrame ("button", "TESTE", UIParent, "SecureActionButtonTemplate")
teste:SetSize (200, 200)
teste:SetBackdrop (block_backdrop)
teste:SetPoint ("center", UIParent, "center")

teste:RegisterForClicks ("AnyUp")
teste:SetAttribute ("type1", "macro")
teste:SetAttribute ("type2", "macro")

teste:SetAttribute ("macrotext", "/target Irtzertluz\n/say %t\n/click ExtraActionButton1\n/targetlasttarget") -- /say %t\n
teste:SetAttribute ("macrotext2", "/cast [target=raid2] Purify")
--]]

function f:CreatePlayerBlock()

	local b = CreateFrame ("frame", "IskarAssistBlockSupport" .. #f.player_blocks+1, f)
	b:SetSize (100, 20)
	b:SetBackdrop (block_backdrop)
	tinsert (f.player_blocks, b)
	
	local button = CreateFrame ("button", "IskarAssistBlock" .. #f.player_blocks, f, "SecureActionButtonTemplate")
	button:SetSize (100, 20)
	button:SetAllPoints (b)
	button:SetFrameStrata ("tooltip")
	
	button:SetAttribute ("type1", "macro")
	button:SetAttribute ("type2", "spell")
	--button:SetAttribute ("type2", "macro")
	button:RegisterForClicks ("AnyUp")
	
	b.button = button
	
	local name = b:CreateFontString (nil, "overlay", "GameFontHighlight")
	name:SetPoint ("center", b, "center")
	b.playername = name
	
	local eyeanzu = b:CreateTexture (nil, "overlay")
	eyeanzu:SetPoint ("left", b, "left")
	eyeanzu:SetSize (30, 30)
	b.eyeanzu = eyeanzu
	
	b.debuffs = {}
	for i = 1, 3 do
		local cooldown_support = CreateFrame ("frame", nil, b)
		tinsert (b.debuffs, cooldown_support)
		cooldown_support:SetSize (20, 20)

		local texture = cooldown_support:CreateTexture (nil, "border")
		texture:SetPoint ("topleft", cooldown_support, "topleft")
		texture:SetPoint ("bottomright", cooldown_support, "bottomright")
		cooldown_support.texture = texture
		
		if (i == 1) then
			cooldown_support:SetPoint ("right", b, "left", -3, 0)
		else
			cooldown_support:SetPoint ("right", b.debuffs [i-1], "left", -3, 0)
		end
		
		local cooldown = CreateFrame ("cooldown", "IskarAssistCD" .. #f.player_blocks .. "_" .. i, cooldown_support, "CooldownFrameTemplate")
		cooldown:SetAllPoints()
		cooldown_support.cooldown = cooldown
		
		cooldown_support:Hide()
	end
	
	b:SetPoint ("topleft", f, "topleft", 2, (#f.player_blocks*21*-1) + 20)
	f:SetHeight (20 + (21*#f.player_blocks))
	
	return b
end

function f:ClearFrames()
	for _, block in ipairs (f.player_blocks) do
		block:SetBackdrop (block_backdrop)
		for _, debuff in ipairs (block.debuffs) do
			debuff.cooldown:SetCooldown (0, 0, 0, 0)
			debuff:Hide()
		end
	end
	anzu_texture:ClearAllPoints()
end

local allplayers = {}
local player_index = {}

local sort = function(a, b)
	return a < b
end

local _, player_class = UnitClass ("player")

function f:SortGroups()
	
	if (UnitAffectingCombat ("player") or InCombatLockdown()) then
		f:Msg ("in Combat, can't update unit frame, scheduling up...")
		f.schedule_sort = true
		return
	end
	
	f:debug ("Building the unit frame...")
	
	f.schedule_sort = false
	
	wipe (allplayers)
	local unitids = {}
	for i = 1, GetNumGroupMembers() do
		local fullname = GetUnitName ("raid" .. i, true)
		tinsert (allplayers, fullname)
		unitids [fullname] = "raid" .. i
	end
	table.sort (allplayers, sort)
	 
	for i = 1, #f.player_blocks do
		f.player_blocks[i]:Hide()
	end
	
	for i = 1, #allplayers do
		local block = f.player_blocks [i]
		if (not block) then
			block = f:CreatePlayerBlock()
		end
		
		player_index [allplayers [i]] = i
		
		block.playername:SetText (allplayers [i]:gsub (("%-.*"), ""))
		local _, class = UnitClass (allplayers [i])
		if (class) then
			local color = RAID_CLASS_COLORS [class]
			block:SetBackdropColor (color.r, color.g, color.b)
		else
			block:SetBackdropColor (.8, .8, .8)
		end

		block.button:SetAttribute ("macrotext", "/target " .. (allplayers [i] or "") .. "\n/click ExtraActionButton1\n/targetlasttarget") -- /say %t\n
		block.button:SetAttribute ("unit", unitids [allplayers [i]] or "")

		if (player_class == "PRIEST") then
			local spellname = GetSpellInfo (527) --Purify
			block.button:SetAttribute ("spell2", spellname)
			--block.button:SetAttribute ("macrotext2", "/cast [target=" .. unitids [allplayers [i]] .. "] " .. spellname)
		elseif (player_class == "PALADIN") then
			local spellname = GetSpellInfo (4987) --cleanse
			block.button:SetAttribute ("spell2", spellname)
		elseif (player_class == "SHAMAN") then
			local spellname = GetSpellInfo (77130) --Purify Spirit
			block.button:SetAttribute ("spell2", spellname)
		elseif (player_class == "DRUID") then
			local spellname = GetSpellInfo (88423)
			block.button:SetAttribute ("spell2", spellname) --Nature's Cure
		elseif (player_class == "MONK") then
			local spellname = GetSpellInfo (115450) --Detox
			block.button:SetAttribute ("spell2", spellname)
		end

		block.name = allplayers [i]
		
		block:Show()
	end
	
end

f:SetScript ("OnShow", function (self)
	f.enabled = true
	f:SortGroups()
end)
f:SetScript ("OnHide", function (self)
	f.enabled = false
end)

function f:SetAnzu (target_name)
	local block = f.player_blocks [player_index [target_name]]
	if (block) then
		block:SetBackdrop (block_backdrop_eye)
		block:SetBackdropColor (1, 1, 0)
		anzu_texture:SetPoint ("left", block, "left", 2, 0)
		anzu_texture:SetParent (block)
	end
	f:debug ("Anzu on", target_name)
end

function f:RemoveAnzu (target_name)
	local block = f.player_blocks [player_index [target_name]]
	if (block) then
		block:SetBackdrop (block_backdrop)
		anzu_texture:ClearAllPoints()
	end
	f:debug ("Anzu leaves", target_name)
end

function f:SetAura (target_name, spellname, spellid)
	local block = f.player_blocks [player_index [target_name]]
	
	if (block) then
		local isDose = false
		for i = 1, 3 do
			local d = block.debuffs [i]
			if (d:IsShown() and d.spell == spellname) then
				local _, _, icon, count, _, duration, expirationTime = UnitDebuff (target_name, spellname)
				if (expirationTime) then
					d.cooldown:SetCooldown (GetTime(), expirationTime-GetTime(), 0, 0)
				end
				isDose = true
				break
			end
		end
		
		if (not isDose) then
			for i = 1, 3 do
				local d = block.debuffs [i]
				if (not d:IsShown()) then
					d:Show()
					
					local _, _, icon, count, _, duration, expirationTime = UnitDebuff (target_name, spellname)
					if (expirationTime) then
						d.cooldown:SetCooldown (GetTime(), expirationTime-GetTime(), 0, 0)
					end
					
					local _, _, icon = GetSpellInfo (spellid)
					d.texture:SetTexture (icon)
					d.texture:SetTexCoord (4/64, 60/64, 4/64, 60/64)
					
					d.spell = spellname
					
					break
				end
			end
		end
	end
end

function f:RemoveAura (target_name, spellname, spellid)
	local block = f.player_blocks [player_index [target_name]]
	if (block) then
		for i = 1, 3 do
			local d = block.debuffs [i]
			if (d:IsShown() and d.spell == spellname) then
				d.cooldown:SetCooldown (0, 0, 0, 0)
				d:Hide()
				d.spell = nil
				break
			end
		end
	end
end

frame_event:SetScript ("OnEvent", function (self, event, ...)

	if (event == "PARTY_MEMBERS_CHANGED" or event == "GROUP_ROSTER_UPDATE" or event == "UNIT_NAME_UPDATE" or event == "PLAYER_ENTERING_WORLD") then
		if (IskarAssist:IsShown()) then
			f:debug ("Party Members Update")
			f:SortGroups()
		end
		
	elseif (event == "PLAYER_TARGET_CHANGED") then
		if (not f:IsShown()) then
			local GUID = UnitGUID ("target")
			if (GUID) then
				local npcid = select (6, strsplit ("-", GUID))
				if (npcid) then
					if (tonumber (npcid) == 90316) then
						f:Show()
					end
				end
			end
		end
		
	elseif (event == "PLAYER_REGEN_ENABLED") then
		if (f.schedule_sort) then
			f:SortGroups()
			f:debug ("Regen Enabled with a schedule sort.")
		end
		
	elseif (event == "ADDON_LOADED" and select (1, ...) == "IskarAssist") then

		db = IskarAssistDB
		if (not db) then
			db = {}
			IskarAssistDB = db
		end
		
	elseif (event == "ENCOUNTER_START" or event == "ENCOUNTER_END") then
	
		local encounterID, encounterName, difficultyID, raidSize, endStatus = select (1, ...)
		--print (encounterID, encounterName, difficultyID, raidSize, endStatus)
		
		if (encounterID == 1788) then
			if (event == "ENCOUNTER_START") then
				f.on_encounter = true
				f:RegisterEvent ("COMBAT_LOG_EVENT_UNFILTERED")
				f:debug ("Encounter Started!")
				
			elseif (event == "ENCOUNTER_END") then
				f.on_encounter = false
				f:UnregisterEvent ("COMBAT_LOG_EVENT_UNFILTERED")
				f:debug ("Encounter End")
				
				f:ClearFrames()
				
				if (endStatus == 1) then
					f:Hide()
				end
			end
		end
	end
end)

local track_auras = {
	[aura_phantasmal_wounds] = true,
	[aura_phantasmal_winds] = true,
	[aura_fel_chakram] = true,
	[aura_phantasmal_corruption] = true,
	[aura_fel_bomb] = true,
	[aura_phantasmal_bomb] = true,
}

--f:RegisterEvent ("COMBAT_LOG_EVENT_UNFILTERED")
f:RegisterEvent ("COMBAT_LOG_EVENT_UNFILTERED")

f:SetScript ("OnEvent", function (self, event, time, token, _, who_serial, who_name, who_flags, _, target_serial, target_name, target_flags, _, spellid, spellname, spellschool, buff_type, buff_name)
	if (token == "SPELL_AURA_APPLIED" or token == "SPELL_AURA_REFRESH" or token == "SPELL_AURA_APPLIED_DOSE") then
		if (spellname == aura_eyeanzu) then
			f:SetAnzu (target_name)
		elseif (track_auras [spellname]) then
			f:SetAura (target_name, spellname, spellid)
		end
		
	elseif (token == "SPELL_AURA_REMOVED") then
		if (spellname == aura_eyeanzu) then
			f:RemoveAnzu (target_name)
		elseif (track_auras [spellname]) then
			f:RemoveAura (target_name, spellname, spellid)
		end
	end
end)

function f:Msg (msg)
	print ("|cFFFFAA00Iskar Assist|r:", msg)
end

SLASH_IskarAssist1 = "/iskar"
function SlashCmdList.IskarAssist (msg, editbox)

	local command, rest = msg:match ("^(%S*)%s*(.-)$")

	if (command == "users") then
		if (f.users_schedule) then
			f:Msg ("please wait 5 seconds...")
		elseif (IsInRaid()) then
			f.users = {}
			f:SendCommMessage ("HAFR", "US", "RAID")
			f.users_schedule = f:ScheduleTimer ("ShowUsers", 5)
			f:Msg ("please wait 5 seconds...")
		else
			f:Msg ("you aren't in a raid group.")
		end
	
	elseif (command == "resetpos") then
	
	else
		f:Msg ("|cFF00FF00" .. f.version .. "|r")
		f:Show()
	end
end

local AceTimer = LibStub:GetLibrary ("AceTimer-3.0")
AceTimer:Embed (f)
local AceComm = LibStub:GetLibrary ("AceComm-3.0")
AceComm:Embed (f)

function f:CommReceived (_, data, _, source)
	if (data == "US") then
		f:SendCommMessage ("HAFR", UnitName ("player") .. " " .. f.version, "RAID")
	elseif (f.users) then
		f.users [data] = true
	end
end
function f:ShowUsers()
	
	local users_frame = IskarAssistUsersPanel
	if (not users_frame) then
		users_frame = CreateFrame ("frame", "IskarAssistUsersPanel", UIParent)
		users_frame:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, insets = {left = -1, right = -1, top = -1, bottom = -1},
		edgeFile = "Interface\\AddOns\\IskarAssist\\border_2", edgeSize = 8})
		users_frame:SetBackdropColor (0, 0, 0, 1)
		tinsert (UISpecialFrames, "IskarAssistUsersPanelUsersPanel")
		users_frame:SetSize (200, 500)
		users_frame:SetPoint ("right", f, "left", -15, 0)
		users_frame.text = users_frame:CreateFontString (nil, "overlay", "GameFontHighlight")
		users_frame.text:SetPoint ("topleft", users_frame, "topleft", 10, -10)
		users_frame.text:SetJustifyH ("left")
		
		users_frame.title = users_frame:CreateFontString (nil, "overlay", "GameFontNormal")
		users_frame.title:SetText ("Iskar Assist: Users")
		users_frame.title:SetPoint ("center", users_frame, "center")
		users_frame.title:SetPoint ("bottom", users_frame, "top", 0, 2)
	end
	
	local s = ""
	
	for key, value in pairs (f.users) do
		s = s .. "|cFF33FF33" .. key .. "\n"
	end
	
	s = s .. "|r\n\n\n|cFFFFFFFFOut of Date or Not installed:|r\n\n"
	
	for i = 1, GetNumGroupMembers() do
		local name = UnitName ("raid" .. i)
		if (not s:find (name)) then
			s = s .. "|cFFFF3333" .. name .. "|r\n"
		end
	end
	
	users_frame.text:SetText (s)
	
	users_frame:Show()

	f.users = nil
	f.users_schedule = nil
	
end
--
f:RegisterComm ("HAFR", "CommReceived")
